﻿Imports System.Data
Imports System.Configuration
Imports System.Data.SqlClient
Partial Class VB
    Inherits System.Web.UI.Page
    Protected Sub Page_Load(sender As Object, e As EventArgs) Handles Me.Load
        If Not IsPostBack Then
            Me.BindGrid()
        End If
    End Sub

    Private Sub BindGrid()
        Dim query As String = "SELECT Id, Location, Preference FROM HolidayLocations ORDER BY Preference"
        Dim constr As String = ConfigurationManager.ConnectionStrings("constr").ConnectionString
        Using con As New SqlConnection(constr)
            Using cmd As New SqlCommand(query)
                Using sda As New SqlDataAdapter()
                    cmd.CommandType = CommandType.Text
                    cmd.Connection = con
                    sda.SelectCommand = cmd
                    Using dt As New DataTable()
                        sda.Fill(dt)
                        gvLocations.DataSource = dt
                        gvLocations.DataBind()
                    End Using
                End Using
            End Using
        End Using
        Dim lnkUp As LinkButton = TryCast(gvLocations.Rows(0).FindControl("lnkUp"), LinkButton)
        Dim lnkDown As LinkButton = TryCast(gvLocations.Rows(gvLocations.Rows.Count - 1).FindControl("lnkDown"), LinkButton)
        lnkUp.Enabled = False
        lnkUp.CssClass = "button disabled"
        lnkDown.Enabled = False
        lnkDown.CssClass = "button disabled"
    End Sub

    Protected Sub ChangePreference(sender As Object, e As EventArgs)
        Dim commandArgument As String = TryCast(sender, LinkButton).CommandArgument

        Dim rowIndex As Integer = TryCast(TryCast(sender, LinkButton).NamingContainer, GridViewRow).RowIndex
        Dim locationId As Integer = Convert.ToInt32(gvLocations.Rows(rowIndex).Cells(0).Text)
        Dim preference As Integer = Convert.ToInt32(gvLocations.DataKeys(rowIndex).Value)
        preference = If(commandArgument = "up", preference - 1, preference + 1)
        Me.UpdatePreference(locationId, preference)

        rowIndex = If(commandArgument = "up", rowIndex - 1, rowIndex + 1)
        locationId = Convert.ToInt32(gvLocations.Rows(rowIndex).Cells(0).Text)
        preference = Convert.ToInt32(gvLocations.DataKeys(rowIndex).Value)
        preference = If(commandArgument = "up", preference + 1, preference - 1)
        Me.UpdatePreference(locationId, preference)

        Response.Redirect(Request.Url.AbsoluteUri)
    End Sub

    Private Sub UpdatePreference(locationId As Integer, preference As Integer)
        Dim constr As String = ConfigurationManager.ConnectionStrings("constr").ConnectionString
        Using con As New SqlConnection(constr)
            Using cmd As New SqlCommand("UPDATE HolidayLocations SET Preference = @Preference WHERE Id = @Id")
                Using sda As New SqlDataAdapter()
                    cmd.CommandType = CommandType.Text
                    cmd.Parameters.AddWithValue("@Id", locationId)
                    cmd.Parameters.AddWithValue("@Preference", preference)
                    cmd.Connection = con
                    con.Open()
                    cmd.ExecuteNonQuery()
                    con.Close()
                End Using
            End Using
        End Using
    End Sub
End Class

